import java.awt.*;
import java.awt.event.*;
public class SimExByLU extends Frame
{
   public SimExByLU()
   {  
      setSize(800,300);
      addWindowListener(new WindowAdapter()
      {
         public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [][] MultM(double [][] A,double [][] B,int N1,int N2, int N3)
   {
     double[][]C=new double[N1][N3]; 
     int i,j,k;
      for(i=0;i<N1;i++) for(j=0;j<N3; j++)
      {  C[i][j]=0.0;
         for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
      return C;
   }
   public double [] MultM(double [][] A,double [] B,int N1,int N2)
   {
     double[]C=new double[N1]; 
     int i,j,k;
      for(i=0;i<N1;i++)
      {  C[i]=0.0; for(k=0;k<N2;k++) C[i] += A[i][k] * B[k];
      }
      return C;
   }
   public void LU_D(double [][] A,double [][] L,double [][] U,int N)
   {  int i, j, k; double T;
      for(i = 0; i < N; i++) for(j = 0; j < N; j++) L[i][j] = U[i][j] = 0;
      L[0][0] = 1;
      for(j = 0; j < N; j++) U[0][j] = A[0][j]    ;
      for(i = 1; i < N; i++)
      {  U[i][0] = L[0][i] = 0;  L[i][0] = A[i][0] / U[0][0];
      }
      for(i = 1; i < N; i++)
      {
        L[i][i] = 1; T = A[i][i];
        for(k=0; k<=i; k++) T -= L[i][k] * U[k][i];
        U[i][i] = T;
        for(j=i+1; j < N; j++)
        {   U[j][i] = L[i][j] = 0;
            T = A[j][i];
            for(k = 0; k <= i; k++) T -= L[j][k] * U[k][i];
            L[j][i] = T / U[i][i];
            T = A[i][j];
            for(k = 0; k <= i; k++) T -= L[i][k] * U[k][j];
            U[i][j] = T;
         }
       }
   }
   public void SimEx(double[][]A, double[][]L, double[][]U,
                                double[]B, double[]Y, double[]X, int N)
   {  int i,k; double T;
      LU_D(A, L, U, N);
      for(i=0;i<N;i++)
      { T = B[i]; for(k=0;k<=i-1;k++) T -= L[i][k]*Y[k];
        Y[i]=T;          
      }  
      for(i=N-1;i>=0;i--)
      { T = Y[i]; for(k=i+1;k<N;k++) T -= U[i][k]*X[k];
        X[i]=T/U[i][i];          
      }  
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  
      double DN=10*Math.pow(10.0,(double)(N-1));
      if(Math.abs(D*DN)<0.5) return 0.0;
      return (Math.rint(D*DN))/DN;
   }
 
   public void DrawExp(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [][] B,double [][] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,210,Y+20);
      g.drawString( ope2,410,Y+20);
      for(i=0;i<N1;i++) for(j=0;j<N2; j++)
      {  g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
         g.drawString( "" + round(B[i][j],3),250 + j*50,Y + i*20);
         g.drawString( "" + round(C[i][j],3),450 + j*50,Y + i*20);
      }
      drawBra(g, 40, Y - 10, 50); drawKet(g,190, Y - 10, 50);
      drawBra(g,240, Y - 10, 50); drawKet(g,390, Y - 10, 50);
      drawBra(g,440, Y - 10, 50); drawKet(g,590, Y - 10, 50);
   } 
   public void DrawExp(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [] B,double [] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,210,Y+20);
      g.drawString( ope2,310,Y+20);
      for(i=0;i<N1;i++)
      {
         for(j=0;j<N2; j++)
         {  g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
         }
         g.drawString( "" + round(B[i],3),250 ,Y + i*20);
         g.drawString( "" + round(C[i],3),350 ,Y + i*20);
      }
      drawBra(g, 40, Y - 10, 50); drawKet(g,190, Y - 10, 50);
      drawBra(g,240, Y - 10, 50); drawKet(g,290, Y - 10, 50);
      drawBra(g,340, Y - 10, 50); drawKet(g,390, Y - 10, 50);
   } 
   public void DrawVect(Graphics g,String name, int X, int Y, double [] A, int N)
   {  int i, j;
      g.drawString(name,X,Y);
      for(i=0;i<N;i++) g.drawString( "" + round(A[i],3), X+15,Y + i*20);
      drawBra(g,X+10, Y - 10, 50); drawKet(g,X+60, Y - 10, 50);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A={{6,5,4},{12,13,10},{18,21,17}};
      double [][] L={{0,0,0},{0,0,0},{0,0,0}};
      double [][] U={{0,0,0},{0,0,0},{0,0,0}};
      double []   B={8,16,27};
      double []   X={0,0,0};
      double []   Y={0,0,0};
      setTitle("LUɂA");
      SimEx(A, L, U, B, Y, X, 3);
      DrawExp (g, "","", 50, A, L, U, 3,3);
      DrawVect(g, "X", 630,50,X,3);
      DrawVect(g, "Y", 720,50,Y,3);
      double [][] C = MultM(L, U, 3, 3, 3);
      DrawExp(g, "","", 150, L, U, C, 3,3);
      double [] D = MultM(A, X, 3, 3);
      DrawExp(g, "","", 250, A, X, D, 3,3);
 
   } 
   public static void main(String[] args)
   {
      Frame w = new SimExByLU();
      w.setVisible(true);
   }

}
